﻿using System.Windows;
using System;

namespace GridControlApp
{
	public partial class App : Application 
	{
		public App() 
		{
			this.Startup += this.OnStartup;
			this.Exit += this.OnExit;
			this.UnhandledException += this.Application_UnhandledException;

			InitializeComponent();
		}

		private void OnStartup(object sender, StartupEventArgs e) 
		{
			// メイン コントロールをここに読み込みます
            this.RootVisual = new GridControlPage();
		}

		private void OnExit(object sender, EventArgs e) 
		{
		}

		private void Application_UnhandledException(object sender, ApplicationUnhandledExceptionEventArgs e) 
		{
			// デバッガの範囲外でアプリケーションが実行されている場合、ブラウザの
			//例外機能を使用して例外が報告されます。IE では、この例外はステータス バーの
			//黄色の警告アイコンで示されます。Firefox では、スクリプト エラーが表示されます。
			if (!System.Diagnostics.Debugger.IsAttached)
			{
				// メモ: これにより、例外がスローされたが処理されなかった場合でも、
				//アプリケーションは実行を継続できます。
				// 実稼働アプリケーションでは、このエラー処理を、他の機能 (Web サイトへエラーを報告し、
				//アプリケーションを停止するような機能) に置き換える必要があります。
				e.Handled = true;
				Deployment.Current.Dispatcher.BeginInvoke(delegate { ReportErrorToDOM(e); });
			}
		}

		private void ReportErrorToDOM(ApplicationUnhandledExceptionEventArgs e)
		{
			try
			{
				string errorMsg = e.ExceptionObject.Message + @"\n" + e.ExceptionObject.StackTrace;
				errorMsg = errorMsg.Replace("\"", "\\\"").Replace("\r\n", @"\n");

				System.Windows.Browser.HtmlPage.Window.Eval("throw new Error(\"Unhandled Error in Silverlight 2 Application " + errorMsg + "\");");
			}
			catch (Exception)
			{
			}
		}
	}
}